package cn.iocoder.yudao.module.mes.dal.mysql.task;

import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.mes.dal.dataobject.task.TaskDetailDO;
import cn.iocoder.yudao.module.mes.dal.dataobject.task.TaskDetailSumResult;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * 生产任务单明细 Mapper
 *
 * @author 内蒙必硕
 */
@Mapper
public interface TaskDetailMapper extends BaseMapperX<TaskDetailDO> {

    default List<TaskDetailDO> selectListByTaskId(Long taskId) {
        return selectList(TaskDetailDO::getTaskId, taskId);
    }

    default int deleteByTaskId(Long taskId) {
        return delete(TaskDetailDO::getTaskId, taskId);
    }

    default PageResult<TaskDetailDO> selectPage(PageParam reqVO, Long taskId) {
        return selectPage(reqVO, new LambdaQueryWrapperX<TaskDetailDO>()
                .eq(TaskDetailDO::getTaskId, taskId)
                .orderByDesc(TaskDetailDO::getId));
    }

    public List<TaskDetailSumResult> selectSumListByTaskId(Long taskId);
}